function output = lolik0_sd(beta,dt,cu,ucu)

% Construct the product of empirical score function at states with n = 0

n = length(dt); % the number of samples at the current state

options = optimset('Display','off');

h = 0.01;
beta1 = beta + h;

x00 = 0; 

[x0,x0val] = fsolve(@eqrest0,x00,options,beta,cu,ucu); 
% Computing choice probability when beta is Beta_MLE

[y0,y0val] = fsolve(@eqrest0,x00,options,beta1,cu,ucu);
% Computing choice probability when beta is Beta_MLE + h


cp0 = exp(x0)/(1+exp(x0)); cp2 = exp(y0)/(1+exp(y0));

lik0 = (dt(:,1) == 1)*log(cp0) + (dt(:,1) == 0)*log(1-cp0); 
% Evaluating likelihood function when beta is Beta_MLE

lik2 = (dt(:,1) == 1)*log(cp2) + (dt(:,1) == 0)*log(1-cp2); 
% Evaluating likelihood function when beta is (Beta_MLE + h)

lik_der = (lik0 - lik2)./h;

output = lik_der'*lik_der;




