%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Obtain QRE choice probabilities at states and their corresponding payoff
% differences between contributing and not contributing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function output = lolik_EU(xbeta,a10,a20,a21,a22,a30,a31,a32,a40,a41,a42,a50,a51,a52,A)

beta = exp(xbeta);

%%%%%%%%%%%%%%%  t = 5 (last period) and n = 2 %%%%%%%%%%%%%%%%%%%%%%%%%

cu52 = A; ucu52 = A+1;
out = lolik2(beta,a52,cu52,ucu52);
lik52 = out(1); cp52 = out(2);
u52 = cp52*cu52 + (1-cp52)*ucu52;
pd52 = cu52 - ucu52;


%%%%%%%%%%%%%%%  t = 4 (last period) and n = 2 %%%%%%%%%%%%%%%%%%%%%%%%%

cu42 = A; ucu42 = u52;
out = lolik2(beta,a42,cu42,ucu42);
lik42 = out(1); cp42 = out(2);
u42 = cp42*cu42 + (1-cp42)*ucu42;
pd42 = cu42 - ucu42;

%%%%%%%%%%%%%%%  t = 3 (last period) and n = 2 %%%%%%%%%%%%%%%%%%%%%%%%%

cu32 = A; ucu32 = u42;
out = lolik2(beta,a32,cu32,ucu32);
lik32 = out(1); cp32 = out(2);
u32 = cp32*cu32 + (1-cp32)*ucu32;
pd32 = cu32 - ucu32;

%%%%%%%%%%%%%%%  t = 2 (last period) and n = 2 %%%%%%%%%%%%%%%%%%%%%%%%%

cu22 = A; ucu22 = u32;
out = lolik2(beta,a22,cu22,ucu22);
lik22 = out(1); cp22 = out(2);
u22 = cp22*cu22 + (1-cp22)*ucu22;
pd22 = cu22 - ucu22;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cu51 = A; ucu51 = [1;A+1];
out = lolik1(beta,a51,cu51,ucu51);
lik51 = out(1); cp51 = out(2); 
u51 = cp51*cu51 + (1-cp51)*((1-cp51)*ucu51(1)+cp51*ucu51(2));
pd51 = cu51 - ((1-cp51)*ucu51(1)+cp51*ucu51(2));

cu41 = A; ucu41 = [u51;u52];
out = lolik1(beta,a41,cu41,ucu41);
lik41 = out(1); cp41 = out(2);
u41 = cp41*cu41 + (1-cp41)*((1-cp41)*ucu41(1)+cp41*ucu41(2));
pd41 = cu41 - ((1-cp41)*ucu41(1)+cp41*ucu41(2));

cu31 = A; ucu31 = [u41;u42];
out = lolik1(beta,a31,cu31,ucu31);
lik31 = out(1); cp31 = out(2);
u31 = cp31*cu31 + (1-cp31)*((1-cp31)*ucu31(1)+cp31*ucu31(2));
pd31 = cu31 - ((1-cp31)*ucu31(1)+cp31*ucu31(2));

cu21 = A; ucu21 = [u31;u32];
out = lolik1(beta,a21,cu21,ucu21);
lik21 = out(1); cp21 = out(2);
u21 = cp21*cu21 + (1-cp21)*((1-cp21)*ucu21(1)+cp21*ucu21(2));
pd21 = cu21 - ((1-cp21)*ucu21(1)+cp21*ucu21(2));

cu50 = [0;A]; ucu50 = [1;1;A+1];
out = lolik0(beta,a50,cu50,ucu50);
lik50 = out(1); cp50 = out(2);
term1 = cp50*(((1-cp50)^2)*cu50(1)+(1-((1-cp50)^2))*cu50(2));
term0 = (1-cp50)*(((1-cp50)^2)*ucu50(1)+2*(1-cp50)*cp50*ucu50(2)+(cp50^2)*ucu50(3));
u50 = term1 + term0; c51 = ((1-cp51)^2)*cu50(1)+(1-(1-cp51)^2)*cu50(2);
pd50 = (((1-cp50)^2)*cu50(1)+(1-((1-cp50)^2))*cu50(2)) - (((1-cp50)^2)*ucu50(1)+2*(1-cp50)*cp50*ucu50(2)+(cp50^2)*ucu50(3));

cu40 = [c51;A]; ucu40 = [u50;u51;u52];
out = lolik0(beta,a40,cu40,ucu40);
lik40 = out(1); cp40 = out(2);
term1 = cp40*(((1-cp40)^2)*cu40(1)+(1-((1-cp40)^2))*cu40(2));
term0 = (1-cp40)*(((1-cp40)^2)*ucu40(1)+2*(1-cp40)*cp40*ucu40(2)+(cp40^2)*ucu40(3));
u40 = term1 + term0; c41 = ((1-cp41)^2)*cu40(1)+(1-(1-cp41)^2)*cu40(2);
pd40 = -(((1-cp40)^2)*ucu40(1)+2*(1-cp40)*cp40*ucu40(2)+(cp40^2)*ucu40(3)) + (((1-cp40)^2)*cu40(1)+(1-((1-cp40)^2))*cu40(2));

cu30 = [c41;A]; ucu30 = [u40;u41;u42];
out = lolik0(beta,a30,cu30,ucu30);
lik30 = out(1); cp30 = out(2);
term1 = cp30*(((1-cp30)^2)*cu30(1)+(1-((1-cp30)^2))*cu30(2));
term0 = (1-cp30)*(((1-cp30)^2)*ucu30(1)+2*(1-cp30)*cp30*ucu30(2)+(cp30^2)*ucu30(3));
u30 = term1 + term0; c31 = ((1-cp31)^2)*cu30(1)+(1-(1-cp31)^2)*cu30(2);
pd30 = -(((1-cp30)^2)*ucu30(1)+2*(1-cp30)*cp30*ucu30(2)+(cp30^2)*ucu30(3)) + (((1-cp30)^2)*cu30(1)+(1-((1-cp30)^2))*cu30(2)); 

cu20 = [c31;A]; ucu20 = [u30;u31;u32];
out = lolik0(beta,a20,cu20,ucu20);
lik20 = out(1); cp20 = out(2);
term1 = cp20*(((1-cp20)^2)*cu20(1)+(1-((1-cp20)^2))*cu20(2));
term0 = (1-cp20)*(((1-cp20)^2)*ucu20(1)+2*(1-cp20)*cp20*ucu20(2)+(cp20^2)*ucu20(3));
u20 = term1 + term0; c21 = ((1-cp21)^2)*cu20(1)+(1-(1-cp21)^2)*cu20(2);
pd20 = - (((1-cp20)^2)*ucu20(1)+2*(1-cp20)*cp20*ucu20(2)+(cp20^2)*ucu20(3)) + (((1-cp20)^2)*cu20(1)+(1-((1-cp20)^2))*cu20(2));

cu10 = [c21;A]; ucu10 = [u20;u21;u22];
out = lolik0(beta,a10,cu10,ucu10);
lik10 = out(1); cp10 = out(2);
term1 = cp10*(((1-cp10)^2)*cu10(1)+(1-((1-cp10)^2))*cu10(2));
term0 = (1-cp10)*(((1-cp10)^2)*ucu10(1)+2*(1-cp10)*cp10*ucu10(2)+(cp10^2)*ucu10(3));
u10 = term1 + term0;
pd10 = -(((1-cp10)^2)*ucu10(1)+2*(1-cp10)*cp10*ucu10(2)+(cp10^2)*ucu10(3)) + (((1-cp10)^2)*cu10(1)+(1-((1-cp10)^2))*cu10(2));

output = [cp10,pd10; cp20,pd20; cp21,pd21; cp22,pd22; cp30,pd30; cp31,pd31; cp32,pd32; cp40,pd40; cp41,pd41; cp42,pd42; cp50,pd50; cp51,pd51; cp52,pd52];

